<template>
  <a-form v-if="vdata.currentConfig" ref="formRef" :model="vdata.currentConfig" layout="vertical" :rules="vdata.formRules">
    <a-divider orientation="left">
      <a-tag color="#FF4B33">博实结设备参数配置</a-tag>
    </a-divider>
    <a-row justify="space-between" type="flex">
      <a-col :span="16">
        <a-form-item label="支付成功语音播报内容" name="customContent">
          <a-input v-model:value.trim="vdata.currentConfig.customContent" placeholder="请输入" :suffix="vdata.customContentSuffix" />
          <span class="jeepay-tip-text">1、播报语音自动拼接`${amount}元`，播报时`${amount}`将替换为订单金额<br>
            2、为空将使用默认播报内容，如：微信收款xxx元</span>
        </a-form-item>
      </a-col>
      <a-col :span="11">
        <a-form-item label="appId" name="appId">
          <a-input v-model:value.trim="vdata.currentConfig.appId" placeholder="请输入" />
        </a-form-item>
      </a-col>
      <a-col :span="11">
        <a-form-item label="appSecret" name="appSecret">
          <a-input v-model:value.trim="vdata.currentConfig.appSecret" :placeholder="vdata.configDataDesen.appSecret || '请输入'" />
        </a-form-item>
      </a-col>
      <a-col :span="11">
        <a-form-item label="userCode" name="userCode">
          <a-input v-model:value.trim="vdata.currentConfig.userCode" placeholder="请输入" />
        </a-form-item>
      </a-col>
    </a-row>
  </a-form>
</template>

<script lang="ts" setup>
import {reactive, ref, defineExpose} from 'vue'
 
  // 当前的form
  const formRef = ref()

  const  vdata = reactive({
    isAdd: false,
    // 配置对象
    currentConfig: {} as any,
    customContentSuffix: '${amount}元', // 自定义语音播报内容后缀
    configDataDesen: {
      appSecret: ''
    },
    // 表单规则
    formRules: {
      appId: [{ required: true, message: '请输入appId', trigger: 'blur' }],
      appSecret: [{ required: false, trigger: 'blur' }, {
        validator: (rule, value) => {
          if (!vdata.configDataDesen.appSecret && !value) {
            return Promise.reject('请输入appSecret')
          }
          return Promise.resolve()
        }
      }],
      userCode: [{ required: true, message: '请输入userCode', trigger: 'blur' }]
    }
  })

  // 对外提供的页面的渲染函数 （ currentConfig = 当前配置项 ）
function pageRender(currentConfig: any){
  // 赋值
  if (currentConfig) {
    vdata.currentConfig = currentConfig
  }

  vdata.configDataDesen.appSecret = vdata.currentConfig.appSecret
  vdata.currentConfig.appSecret = ''

  // 重置form验证
  if (formRef.value !== undefined && formRef.value !== null) {
    formRef.value.resetFields()
  }
}

// 对外提供的获取配置参数函数 （返回JSON类型）
function getConfigParams(){
  return formRef.value.validate().then( () => {

    // 处理加密数据字段
    Object.keys(vdata.configDataDesen).forEach(key => {
      // 加密数据 && 空串
      if (!vdata.currentConfig[key]) {
        delete vdata.currentConfig[key]
      }
    })

    return vdata.currentConfig
  })
}

defineExpose({ getConfigParams, pageRender })

</script>
